<?php class construct extends protein { //Extend prtein, which extends baseobject - same restrictions on canCreate
	
	protected static $fields=array(
			'name'=>validator::REQUIRED,
			'description'=>validator::REQUIRED,
			'proteinid'=>array(validator::REQUIRED, validator::INTEGER)
	);
	
	protected static $helpTexts=array(
			'name'=>'A unique name for this construct',
			'description'=>'Short description of this construct',
			'proteinid'=>'The database ID of the parent protein'
	);
	
	
	protected static $adminSelect='SELECT SQL_CALC_FOUND_ROWS construct.*, project.name AS projectname, project.isarchived AS isarchived, 
			protein.name AS proteinname, protein.proteinacronym as proteinacronym
			FROM construct, protein, project WHERE project.id=construct.projectid AND protein.id=construct.proteinid';
	protected static $normalSelect='SELECT SQL_CALC_FOUND_ROWS construct.*, project.name AS projectname, project.isarchived AS isarchived, 
			protein.name AS proteinname, protein.proteinacronym as proteinacronym
			FROM construct, protein, project WHERE project.id=construct.projectid AND protein.id=construct.proteinid';
	
	
	public static function create($request=array()){
		if(!isset($request['proteinid'])){ throw new BadRequestException('No parent protein specified'); }
		$prot=protein::getById($request['proteinid']); //NotFoundException if can't read it
		if(!session::isAdmin()){
			$proj=project::getById($prot['projectid']); //NotFoundException if can't read it
			if($proj['owner']!=session::getUserId()){
				throw new ForbiddenException('You must own the project to create proteins and constructs in it');
			}
		}
		$request['projectid']=$prot['projectid'];
		$result=baseobject::create($request,'construct');
// 		if(isset($result['created']) && isset($request['dnasequence'])){
// 			$request['constructid']=$result['created']['id'];
// 			sequence::create($request);
// 		}
		return $result;
	}
	
	/**
	 * Gets all constructs (visible to the user) with the specified name. A custom implementation is needed here because, 
	 * unlike most types, the name of a construct is not guaranteed to be globally unique. It is unique only within a 
	 * given protein; several proteins even in the same project might have a "Full length" construct, for example.
	 * @param unknown $name
	 * @param unknown $request
	 * @return multitype:
	 */
	public static function getByName($name, $request=array()){
		return self::getByProperty('name', $name, $request);
	}
	
	public static function getsequences($id,$request=array()){
		return sequence::getByProperty('constructid',$id,$request);
	}
}

?>