<?php 


$dir=dirname(realpath(__FILE__));
include_once($dir.'/../../classes/core/database.class.php');
include_once($dir.'/../../classes/core/exception/ServerException.class.php');

database::connect();

$files=scandir($dir);
foreach($files as $f){
	if('.'==$f || '..'==$f){ continue; }
	if('parser.php'==$f){ continue; }
	echo $f.'<br/>';
	$brick=array(
		'name'=>'',
		'title'=>'',
		'height'=>1,
		'width'=>1,
		'url'=>'',
		'headerTemplates'=>'',
		'rowTemplates'=>'',
		'handler'=>'',
		'content'=>'',
		'admin_only'=>'no'
	);
	$lines=file($dir.'/'.$f);
	$reachedSplit=false;
	foreach($lines as $line){
		if(substr($line,0,2)=='--'){
			$reachedSplit=true;
			array_shift($lines);
			break;
		}
		$line=trim($line);
		$parts=explode('=',$line,2);
		if(count($parts)!=2){
			die('invalid line: '.$line);
		}
		$brick[$parts[0]]=$parts[1];	
		array_shift($lines);
	}
	$remainder=implode(PHP_EOL,$lines);
	if(empty($brick['url'])){
		$brick['content']=$remainder;
	} else {
		$brick['handler']=$remainder;
	}
	
	$colsToFields=array(
		//file=>SQL
		'name'=>'name',
		'title'=>'title',
		'description'=>'description',
		'version'=>'version',
		'height'=>'height',
		'width'=>'width',
		'url'=>'apiurl',
		'headerTemplates'=>'headertemplates',
		'rowTemplates'=>'rowtemplates',
		'admin_only'=>'adminonly',
		'handler'=>'scriptblock',
		'content'=>'content',
	);

	if(empty($brick['name'])){ die("Brick name cannot be empty"); }
	if(empty($brick['title'])){ die("Brick title cannot be empty"); }

	$brick['admin_only']=strtolower($brick['admin_only']);
	if("yes"===$brick['admin_only'] || 'true'===$brick['admin_only'] || '1'===$brick['admin_only']){
		$brick['admin_only']=true;
	} else {
		$brick['admin_only']=false;
	}

	$result=database::queryGetOne('SELECT * FROM homepagebrick WHERE name=:name', array(':name'=>$brick['name']));
	if($result){
		//update
		$sql='UPDATE homepagebrick SET ';
		$parts=array();
		$params=array();
		foreach($brick as $k=>$v){
			if(empty($v) && $k!='handler' && $k!='admin_only'){ $v=''; }
			$parts[]=$colsToFields[$k].'=:'.$k;
			$params[':'.$k]=$v;
		}
		$sql.=implode(', ',$parts);
		$sql.=' WHERE name=:name2';
		$params[':name2']=$brick['name'];
		try {
			database::query($sql, $params);
		} catch(Exception $e){
			echo'<br/><span style="color:red">';
			var_dump($e);
			echo '</span><br/>';
		}
	} else {
		//insert new
		$keys=array();
		$values=array();
		$params=array();
		foreach($brick as $k=>$v){
			if(empty($v)){ continue; }
			$keys[]=$colsToFields[$k];
			$values[]=':'.$k;
			$params[':'.$k]=$v;
		}
		$sql='INSERT INTO homepagebrick (';
		$sql.=implode(', ',$keys);
		$sql.=') VALUES (';
		$sql.=implode(', ',$values);
		$sql.=')';
		try {
			database::query($sql, $params);
		} catch(Exception $e){
			echo'<br/><span style="color:red">';
			var_dump($e);
			echo '</span><br/>';
		}
	}
	
	echo '<hr/>';
}
?>