<?php $pageTitle='Plate: '.$data['name'];
$breadcrumbs=array(
		array('url'=>'/project/'.$data['projectid'], 'icon'=>'project', 'help'=>'Go to this plate\'s project')
);
include realpath(__DIR__).'/../../core/_common/header.php'; ?>
<script type="text/javascript">
var canEdit=<?php echo plate::canUpdate($data['id'])?'true':'false'; ?>;
if(!canEdit && data.ownerid==userId){ canEdit=true; }

document.observe("dom:loaded",function(){

	ui.grid();

	var details=grid.box({
		classes:'r1 c1 h3 w1',
		title:'Details'
	});
	var df=details.form({
		action:'/api/plate/'+data.id,
		method:'patch'
	});
	df.textField({
		label:'Barcode',
		value:data.name,
		readonly:true
	});
	df.formField({ label:"Plate type"}).innerHTML+='<a href="/platetype/'+data.platetypeid+'">'+data.platetypename+'</a>';
	df.formField({ label:"Project", id:'project' }).innerHTML+='<a href="/project/'+data.projectid+'">'+data.projectname+'</a>';
	df.roleField({
		readonly:!isAdmin,
		label:"Owner", 
		name:'ownerid', 
		otherId:data.ownerid, 
		otherName:data.ownername, 
		otherType:'user',
		labelField:'fullname',
		headers:['Name'],
		cellTemplates:['{{fullname}}']
	});

	if(data.locationid){
		df.textField({
			label:'Location',
			id:'locationid',
			value:'Getting location...',
			readonly:true
		});
		//firstly request the location's baseobject so we know what type it is...
		new Ajax.Request('/api/baseobject/'+data.locationid, {
			method:'get',
			onSuccess:function(transport){
				var loc=transport.responseJSON;
				//...then request the actual object
				var locType=loc.objecttype;
				new Ajax.Request('/api/'+locType+'/'+loc.id,{
					method:'get',
					onSuccess:function(transport){
						var loc=transport.responseJSON;
						var locId=loc.id;
						var locName=loc.name;
						if(loc.friendlyname){ locName=loc.friendlyname; }
						var locLink='<a href="/'+locType+'/'+locId+'">'+locName+'</a>';
						$("locationid_label").innerHTML=$("locationid_label").innerHTML.replace("Getting location...",locLink);
					},
					onFailure:function(transport){
						$("locationid_label").remove();
					},
				});
			},
			onFailure:function(transport){
				$("locationid_label").remove();
			},
		});
		
	}


	
	var ts=grid.tabSet({ 
		classes:'r1 c2 h3 w2'
	});

	ts.tab({
		id:'inspections',
		label:'Inspections',
		url:'/api/plate/'+data['id']+'/imagingsession?sortby=imageddatetime&sortdescending=1',
		headers:['Inspection','Temperature','Imager'],
		cellTemplates:[ [Plate.writeInspectionLink,'imageddatetime'],'{{temperature}}C', '<a href="/imager/{{imagerid}}" title="{{imagername}}">{{imagerfriendlyname}}</a>']
	});

	var prot=ts.tab({
		id:'proteins',
		label:'Protein',
		renderer:Plate.renderProteinTab,
	});

	var scr=ts.tab({
		id:'screens',
		label:'Screen',
		renderer:Plate.renderScreenTab,
	});

	var dc=ts.tab({
		id:'drops',
		label:'Drop conditions',
		renderer:Plate.renderDropConditionsTab,
	});
	dc.onclick=Plate.renderDropConditionsTab; //Force render onclick because width doesn't take.

	var filesTab=ts.filesTab(data.screenid);
	ts.notesTab();

	Plate.getPlateType();
	Plate.getWellDrops();
	
});

/*
 * Plate "class" moved to client.js
 */


</script>
<?php 
include realpath(__DIR__).'/../../core/_common/footer.php';
?>